Index: /LMDZ5/branches/testing/libf/dyn3dpar/groupe_p.F
===================================================================
--- /LMDZ5/branches/testing/libf/dyn3dpar/groupe_p.F	(revision 2470)
+++ /LMDZ5/branches/testing/libf/dyn3dpar/groupe_p.F	(revision 2471)
@@ -20,6 +20,6 @@
 #include "comvert.h"
 
-      integer ngroup
-      parameter (ngroup=3)
+!     integer ngroup
+!     parameter (ngroup=3)
 
 
Index: /LMDZ5/branches/testing/libf/dyn3dpar/groupeun_p.F
===================================================================
--- /LMDZ5/branches/testing/libf/dyn3dpar/groupeun_p.F	(revision 2470)
+++ /LMDZ5/branches/testing/libf/dyn3dpar/groupeun_p.F	(revision 2471)
@@ -12,6 +12,6 @@
       REAL q(iip1,jjmax,llmax)
 
-      INTEGER ngroup
-      PARAMETER (ngroup=3)
+!     INTEGER ngroup
+!     PARAMETER (ngroup=3)
 
       REAL airecn,qn
@@ -38,7 +38,7 @@
       LOGICAL, SAVE :: first = .TRUE.
 !$OMP THREADPRIVATE(first)
-      INTEGER,SAVE :: i_index(iim,ngroup)
+!     INTEGER,SAVE :: i_index(iim,ngroup)
       INTEGER      :: offset
-      REAL         :: qsum(iim/ngroup)
+!     REAL         :: qsum(iim/ngroup)
 
       IF (first) THEN
@@ -143,6 +143,6 @@
 #include "comgeom2.h"
 
-      INTEGER ngroup
-      PARAMETER (ngroup=3)
+!     INTEGER ngroup
+!     PARAMETER (ngroup=3)
 
       REAL airen,airecn
Index: /LMDZ5/branches/testing/libf/dynphy_lonlat/phylmd/ce0l.F90
===================================================================
--- /LMDZ5/branches/testing/libf/dynphy_lonlat/phylmd/ce0l.F90	(revision 2470)
+++ /LMDZ5/branches/testing/libf/dynphy_lonlat/phylmd/ce0l.F90	(revision 2471)
@@ -27,10 +27,7 @@
   USE iniphysiq_mod,  ONLY: iniphysiq
   USE mod_const_mpi,  ONLY: comm_lmdz
-#ifdef inca
-  USE indice_sol_mod, ONLY: nbsrf, is_oce, is_sic, is_ter, is_lic
-#endif
 #ifdef CPP_PARA
   USE mod_const_mpi,  ONLY: init_const_mpi
-  USE parallel_lmdz,  ONLY: init_parallel, mpi_rank, omp_rank, mpi_size
+  USE parallel_lmdz,  ONLY: init_parallel, mpi_rank, omp_rank
   USE bands,          ONLY: read_distrib, distrib_phys
   USE mod_hallo,      ONLY: init_mod_hallo
@@ -116,13 +113,4 @@
 
 !--- Tracers initializations
-  IF (type_trac == 'inca') THEN
-#ifdef INCA
-    CALL init_const_lmdz(nbtr,anneeref,dayref,iphysiq,day_step,nday,&
-                         nbsrf,is_oce,is_sic,is_ter,is_lic,calend)
-    CALL init_inca_para(iim,jjp1,llm,klon_glo,mpi_size,distrib_phys,&
-                        COMM_LMDZ)
-    WRITE(lunout,*)'nbtr =' , nbtr 
-#endif
-  END IF
   CALL infotrac_init()
 
Index: /LMDZ5/branches/testing/libf/dynphy_lonlat/phylmd/etat0phys_netcdf.F90
===================================================================
--- /LMDZ5/branches/testing/libf/dynphy_lonlat/phylmd/etat0phys_netcdf.F90	(revision 2470)
+++ /LMDZ5/branches/testing/libf/dynphy_lonlat/phylmd/etat0phys_netcdf.F90	(revision 2471)
@@ -86,4 +86,5 @@
   USE conf_phys_m, ONLY: conf_phys
   USE init_ssrf_m, ONLY: start_init_subsurf
+  !use ioipsl_getincom
   IMPLICIT NONE
 !-------------------------------------------------------------------------------
@@ -97,5 +98,5 @@
   LOGICAL            :: read_mask
   REAL               :: phystep, dummy
-  REAL, DIMENSION(SIZE(masque,1),SIZE(masque,2)) :: masque_tmp
+  REAL, DIMENSION(SIZE(masque,1),SIZE(masque,2)) :: masque_tmp,phiso
   REAL, DIMENSION(klon)               :: sn, rugmer, run_off_lic_0, fder
   REAL, DIMENSION(klon,nbsrf)         :: qsolsrf, snsrf
@@ -115,4 +116,5 @@
   INTEGER :: read_climoz                        !--- Read ozone climatology
   REAL    :: alp_offset
+  LOGICAL :: filtre_oro=.false.
 
   deg2rad= pi/180.0
@@ -142,4 +144,8 @@
   read_mask=ANY(masque/=-99999.); masque_tmp=masque
   CALL start_init_orog(rlonv, rlatu, phis, masque_tmp)
+
+  CALL getin('filtre_oro',filtre_oro)
+  IF (filtre_oro) CALL filtreoro(size(phis,1),size(phis,2),phis,masque_tmp,rlatu)
+
   WRITE(fmt,"(i4,'i1)')")iml ; fmt='('//ADJUSTL(fmt)
   IF(.NOT.read_mask) THEN                       !--- Keep mask form orography
@@ -447,8 +453,54 @@
 !
 !-------------------------------------------------------------------------------
+!
+!*******************************************************************************
+
+SUBROUTINE filtreoro(imp1,jmp1,phis,masque,rlatu)
+
+IMPLICIT NONE
+
+  INTEGER imp1,jmp1
+  REAL, DIMENSION(imp1,jmp1) :: phis,masque
+  REAL, DIMENSION(jmp1) :: rlatu
+  REAL, DIMENSION(imp1) :: wwf
+  REAL, DIMENSION(imp1,jmp1) :: phiso
+  INTEGER :: ifiltre,ifi,ii,i,j
+  REAL :: coslat0,ssz
+
+  coslat0=0.5
+  phiso=phis
+  do j=2,jmp1-1
+     print*,'avant if ',cos(rlatu(j)),coslat0
+     if (cos(rlatu(j))<coslat0) then
+         ! nb de pts affectes par le filtrage de part et d'autre du pt
+         ifiltre=(coslat0/cos(rlatu(j))-1.)/2.
+         wwf=0.
+         do i=1,ifiltre
+            wwf(i)=1.
+         enddo
+         wwf(ifiltre+1)=(coslat0/cos(rlatu(j))-1.)/2.-ifiltre
+         do i=1,imp1-1
+            if (masque(i,j)>0.9) then
+               ssz=phis(i,j)
+               do ifi=1,ifiltre+1
+                  ii=i+ifi
+                  if (ii>imp1-1) ii=ii-imp1+1
+                  ssz=ssz+wwf(ifi)*phis(ii,j)
+                  ii=i-ifi
+                  if (ii<1) ii=ii+imp1-1
+                  ssz=ssz+wwf(ifi)*phis(ii,j)
+               enddo
+               phis(i,j)=ssz*cos(rlatu(j))/coslat0
+            endif
+         enddo
+         print*,'j=',j,coslat0/cos(rlatu(j)), (1.+2.*sum(wwf))*cos(rlatu(j))/coslat0
+     endif
+  enddo
+  call dump2d(imp1,jmp1,phis,'phis ')
+  call dump2d(imp1,jmp1,masque,'masque ')
+  call dump2d(imp1,jmp1,phis-phiso,'dphis ')
+
+END SUBROUTINE filtreoro
 
 
 END MODULE etat0phys
-!
-!*******************************************************************************
-
Index: /LMDZ5/branches/testing/libf/dynphy_lonlat/phylmd/iniphysiq_mod.F90
===================================================================
--- /LMDZ5/branches/testing/libf/dynphy_lonlat/phylmd/iniphysiq_mod.F90	(revision 2470)
+++ /LMDZ5/branches/testing/libf/dynphy_lonlat/phylmd/iniphysiq_mod.F90	(revision 2471)
@@ -47,7 +47,8 @@
 #ifdef INCA
   USE indice_sol_mod, ONLY: nbsrf, is_oce, is_sic, is_ter, is_lic
-  USE parallel_lmdz, ONLY : mpi_size
-  USE mod_const_mpi, ONLY : COMM_LMDZ
+#ifdef CPP_PARA
+  USE parallel_lmdz, ONLY : mpi_size, mpi_rank
   USE bands, ONLY : distrib_phys
+#endif
   USE mod_phys_lmdz_omp_data, ONLY: klon_omp 
 #endif
@@ -115,4 +116,10 @@
   REAL,ALLOCATABLE,SAVE :: boundslatfi(:,:)
 !$OMP THREADPRIVATE (latfi,lonfi,cufi,cvfi,airefi,boundslonfi,boundslatfi)
+
+#ifndef CPP_PARA
+  INTEGER,PARAMETER :: mpi_rank=0
+  INTEGER, PARAMETER :: mpi_size = 1 
+  INTEGER :: distrib_phys(mpi_rank:mpi_rank)=(jjm-1)*iim+2
+#endif
 
   ! Initialize Physics distibution and parameters and interface with dynamics
@@ -295,11 +302,9 @@
 #ifdef INCA
      call init_const_lmdz( &
-          anneeref,dayref, &
-          iphysiq,day_step,nday,  &
-          nbsrf, is_oce,is_sic, &
-          is_ter,is_lic, calend)
+          anneeref,dayref, iphysiq,day_step,nday,  &
+          nbsrf, is_oce,is_sic, is_ter,is_lic, calend)
      call init_inca_para( &
           nbp_lon,nbp_lat,nbp_lev,klon_glo,mpi_size, &
-          distrib_phys,COMM_LMDZ)
+          distrib_phys,communicator)
 #endif
   END IF
Index: /LMDZ5/branches/testing/libf/misc/regr1_conserv_m.F90
===================================================================
--- /LMDZ5/branches/testing/libf/misc/regr1_conserv_m.F90	(revision 2471)
+++ /LMDZ5/branches/testing/libf/misc/regr1_conserv_m.F90	(revision 2471)
@@ -0,0 +1,358 @@
+module regr1_conserv_m
+
+  ! Author: Lionel GUEZ
+
+  use assert_eq_m, only: assert_eq
+  use assert_m, only: assert
+  use interpolation, only: locate
+
+  implicit none
+
+  interface regr1_conserv
+
+     ! This generic procedure regrids a piecewise linear function (not
+     ! necessarily continuous) by averaging it. This is a conservative
+     ! regridding. The regridding operation is done on the first
+     ! dimension of the input array. Input are positions of cell
+     ! edges. The target grid should be included in the source grid:
+     ! no extrapolation is allowed.
+
+     ! The only difference between the procedures is the rank of the
+     ! first argument.
+
+     ! real, intent(in), rank >= 1:: vs ! (ns, ...)
+     ! averages of cells of the source grid
+     ! vs(is, ...) for [xs(is), xs(is + 1)]
+
+     ! real, intent(in):: xs(:) ! (ns + 1)
+     ! edges of cells of the source grid, in strictly ascending order
+
+     ! real, intent(in):: xt(:) ! (nt + 1)
+     ! edges of cells of the target grid, in strictly ascending order
+
+     ! real, intent(in), optional, rank >= 1:: slope ! (ns, ...)
+     ! same rank as vs
+     ! slopes inside cells of the source grid
+     ! slope(is, ...) for [xs(is), xs(is + 1)]
+     ! If not present, slopes are taken equal to 0. The regridding is
+     ! then first order.
+
+     ! real, intent(out), rank >= 1:: vt(nt, ...) 
+     ! has the same rank as vs and slope
+     ! averages of cells of the target grid
+     ! vt(it, ...) for  [xt(it), xt(it + 1)]
+
+     ! ns and nt must be >= 1.
+
+     ! See notes for explanations on the algorithm and justification
+     ! of algorithmic choices.
+
+     module procedure regr11_conserv, regr12_conserv, regr13_conserv, &
+          regr14_conserv
+  end interface regr1_conserv
+
+  private
+  public regr1_conserv
+
+contains
+
+  subroutine regr11_conserv(vs, xs, xt, vt, slope)
+
+    ! vs and slope have rank 1.
+
+    real, intent(in):: vs(:)
+    real, intent(in):: xs(:)
+    real, intent(in):: xt(:)
+    real, intent(out):: vt(:)
+    real, intent(in), optional:: slope(:)
+
+    ! Local:
+    integer is, it, ns, nt
+    logical slope_present
+
+    !---------------------------------------------
+
+    ns = assert_eq(size(vs), size(xs) - 1, "regr11_conserv ns")
+    nt = assert_eq(size(xt) - 1, size(vt), "regr11_conserv nt")
+
+    ! Quick check on sort order:
+    call assert(xs(1) < xs(2), "regr11_conserv xs bad order")
+    call assert(xt(1) < xt(2), "regr11_conserv xt bad order")
+
+    call assert(xs(1) <= xt(1) .and. xt(nt + 1) <= xs(ns + 1), &
+         "regr11_conserv extrapolation")
+    slope_present = present(slope)
+
+    is = locate(xs, xt(1)) ! 1 <= is <= ns, because we forbid extrapolation
+    do it = 1, nt
+       ! 1 <= is <= ns
+       ! xs(is) <= xt(it) < xs(is + 1)
+       if (xt(it + 1) <= xs(is + 1)) then
+          vt(it) = mean_lin(xt(it), xt(it + 1))
+       else
+          vt(it) = mean_lin(xt(it), xs(is + 1)) * (xs(is + 1) - xt(it))
+          is = is + 1
+          do while (xs(is + 1) < xt(it + 1))
+             ! 1 <= is <= ns - 1
+             vt(it) = vt(it) + (xs(is + 1) - xs(is)) * vs(is)
+             is = is + 1
+          end do
+          ! 1 <= is <= ns
+          vt(it) = (vt(it) + mean_lin(xs(is), xt(it + 1)) * (xt(it + 1) &
+               - xs(is))) / (xt(it + 1) - xt(it))
+       end if
+
+       if (xs(is + 1) == xt(it + 1)) is = is + 1
+       ! 1 <= is <= ns .or. it == nt
+    end do
+
+  contains
+
+    real function mean_lin(a, b)
+
+      ! mean in [a, b] of the linear function in [xs(is), xs(is + 1)]
+
+      real, intent(in):: a, b
+
+      !---------------------------------------------
+
+      if (slope_present) then
+         mean_lin = slope(is) / 2. * (a + b - xs(is) - xs(is + 1)) + vs(is)
+      else
+         mean_lin = vs(is)
+      end if
+
+    end function mean_lin
+
+  end subroutine regr11_conserv
+
+  !********************************************
+
+  subroutine regr12_conserv(vs, xs, xt, vt, slope)
+
+    ! vs and slope have rank 2.
+
+    real, intent(in):: vs(:, :)
+    real, intent(in):: xs(:)
+    real, intent(in):: xt(:)
+    real, intent(out):: vt(:, :)
+    real, intent(in), optional:: slope(:, :)
+
+    ! Local:
+    integer is, it, ns, nt, n2
+    logical slope_present
+
+    !---------------------------------------------
+
+    ns = assert_eq(size(vs, 1), size(xs) - 1, "regr12_conserv ns")
+    nt = assert_eq(size(xt) - 1, size(vt, 1), "regr12_conserv nt")
+    n2 = assert_eq(size(vs, 2), size(vt, 2), "regr12_conserv n2")
+
+    ! Quick check on sort order:
+    call assert(xs(1) < xs(2), "regr12_conserv xs bad order")
+    call assert(xt(1) < xt(2), "regr12_conserv xt bad order")
+
+    call assert(xs(1) <= xt(1) .and. xt(nt + 1) <= xs(ns + 1), &
+         "regr12_conserv extrapolation")
+    slope_present = present(slope)
+
+    is = locate(xs, xt(1)) ! 1 <= is <= ns, because we forbid extrapolation
+    do it = 1, nt
+       ! 1 <= is <= ns
+       ! xs(is) <= xt(it) < xs(is + 1)
+       if (xt(it + 1) <= xs(is + 1)) then
+          vt(it, :) = mean_lin(xt(it), xt(it + 1))
+       else
+          vt(it, :) = mean_lin(xt(it), xs(is + 1)) * (xs(is + 1) - xt(it))
+          is = is + 1
+          do while (xs(is + 1) < xt(it + 1))
+             ! 1 <= is <= ns - 1
+             vt(it, :) = vt(it, :) + (xs(is + 1) - xs(is)) * vs(is, :)
+             is = is + 1
+          end do
+          ! 1 <= is <= ns
+          vt(it, :) = (vt(it, :) + mean_lin(xs(is), xt(it + 1)) * (xt(it + 1) &
+               - xs(is))) / (xt(it + 1) - xt(it))
+       end if
+
+       if (xs(is + 1) == xt(it + 1)) is = is + 1
+       ! 1 <= is <= ns .or. it == nt
+    end do
+
+  contains
+
+    function mean_lin(a, b)
+
+      ! mean in [a, b] of the linear function in [xs(is), xs(is + 1)]
+
+      real, intent(in):: a, b
+      real mean_lin(n2)
+
+      !---------------------------------------------
+
+      if (slope_present) then
+         mean_lin = slope(is, :) / 2. * (a + b - xs(is) - xs(is + 1)) &
+              + vs(is, :)
+      else
+         mean_lin = vs(is, :)
+      end if
+
+    end function mean_lin
+
+  end subroutine regr12_conserv
+
+  !********************************************
+
+  subroutine regr13_conserv(vs, xs, xt, vt, slope)
+
+    ! vs and slope have rank 3.
+
+    real, intent(in):: vs(:, :, :)
+    real, intent(in):: xs(:)
+    real, intent(in):: xt(:)
+    real, intent(out):: vt(:, :, :)
+    real, intent(in), optional:: slope(:, :, :)
+
+    ! Local:
+    integer is, it, ns, nt, n2, n3
+    logical slope_present
+
+    !---------------------------------------------
+
+    ns = assert_eq(size(vs, 1), size(xs) - 1, "regr13_conserv ns")
+    nt = assert_eq(size(xt) - 1, size(vt, 1), "regr13_conserv nt")
+    n2 = assert_eq(size(vs, 2), size(vt, 2), "regr13_conserv n2")
+    n3 = assert_eq(size(vs, 3), size(vt, 3), "regr13_conserv n3")
+
+    ! Quick check on sort order:
+    call assert(xs(1) < xs(2), "regr13_conserv xs bad order")
+    call assert(xt(1) < xt(2), "regr13_conserv xt bad order")
+
+    call assert(xs(1) <= xt(1) .and. xt(nt + 1) <= xs(ns + 1), &
+         "regr13_conserv extrapolation")
+    slope_present = present(slope)
+
+    is = locate(xs, xt(1)) ! 1 <= is <= ns, because we forbid extrapolation
+    do it = 1, nt
+       ! 1 <= is <= ns
+       ! xs(is) <= xt(it) < xs(is + 1)
+       if (xt(it + 1) <= xs(is + 1)) then
+          vt(it, :, :) = mean_lin(xt(it), xt(it + 1))
+       else
+          vt(it, :, :) = mean_lin(xt(it), xs(is + 1)) * (xs(is + 1) - xt(it))
+          is = is + 1
+          do while (xs(is + 1) < xt(it + 1))
+             ! 1 <= is <= ns - 1
+             vt(it, :, :) = vt(it, :, :) + (xs(is + 1) - xs(is)) * vs(is, :, :)
+             is = is + 1
+          end do
+          ! 1 <= is <= ns
+          vt(it, :, :) = (vt(it, :, :) + mean_lin(xs(is), xt(it + 1)) &
+               * (xt(it + 1) - xs(is))) / (xt(it + 1) - xt(it))
+       end if
+
+       if (xs(is + 1) == xt(it + 1)) is = is + 1
+       ! 1 <= is <= ns .or. it == nt
+    end do
+
+  contains
+
+    function mean_lin(a, b)
+
+      ! mean in [a, b] of the linear function in [xs(is), xs(is + 1)]
+
+      real, intent(in):: a, b
+      real mean_lin(n2, n3)
+
+      !---------------------------------------------
+
+      if (slope_present) then
+         mean_lin = slope(is, :, :) / 2. * (a + b - xs(is) - xs(is + 1)) &
+              + vs(is, :, :)
+      else
+         mean_lin = vs(is, :, :)
+      end if
+
+    end function mean_lin
+
+  end subroutine regr13_conserv
+
+  !********************************************
+
+  subroutine regr14_conserv(vs, xs, xt, vt, slope)
+
+    ! vs and slope have rank 4.
+
+    real, intent(in):: vs(:, :, :, :)
+    real, intent(in):: xs(:)
+    real, intent(in):: xt(:)
+    real, intent(out):: vt(:, :, :, :)
+    real, intent(in), optional:: slope(:, :, :, :)
+
+    ! Local:
+    integer is, it, ns, nt, n2, n3, n4
+    logical slope_present
+
+    !---------------------------------------------
+
+    ns = assert_eq(size(vs, 1), size(xs) - 1, "regr14_conserv ns")
+    nt = assert_eq(size(xt) - 1, size(vt, 1), "regr14_conserv nt")
+    n2 = assert_eq(size(vs, 2), size(vt, 2), "regr14_conserv n2")
+    n3 = assert_eq(size(vs, 3), size(vt, 3), "regr14_conserv n3")
+    n4 = assert_eq(size(vs, 4), size(vt, 4), "regr14_conserv n4")
+
+    ! Quick check on sort order:
+    call assert(xs(1) < xs(2), "regr14_conserv xs bad order")
+    call assert(xt(1) < xt(2), "regr14_conserv xt bad order")
+
+    call assert(xs(1) <= xt(1) .and. xt(nt + 1) <= xs(ns + 1), &
+         "regr14_conserv extrapolation")
+    slope_present = present(slope)
+
+    is = locate(xs, xt(1)) ! 1 <= is <= ns, because we forbid extrapolation
+    do it = 1, nt
+       ! 1 <= is <= ns
+       ! xs(is) <= xt(it) < xs(is + 1)
+       if (xt(it + 1) <= xs(is + 1)) then
+          vt(it, :, :, :) = mean_lin(xt(it), xt(it + 1))
+       else
+          vt(it, :, :, :) = mean_lin(xt(it), xs(is + 1)) * (xs(is + 1) - xt(it))
+          is = is + 1
+          do while (xs(is + 1) < xt(it + 1))
+             ! 1 <= is <= ns - 1
+             vt(it, :, :, :) = vt(it, :, :, :) + (xs(is + 1) - xs(is)) &
+                  * vs(is, :, :, :)
+             is = is + 1
+          end do
+          ! 1 <= is <= ns
+          vt(it, :, :, :) = (vt(it, :, :, :) + mean_lin(xs(is), xt(it + 1)) &
+               * (xt(it + 1) - xs(is))) / (xt(it + 1) - xt(it))
+       end if
+
+       if (xs(is + 1) == xt(it + 1)) is = is + 1
+       ! 1 <= is <= ns .or. it == nt
+    end do
+
+  contains
+
+    function mean_lin(a, b)
+
+      ! mean in [a, b] of the linear function in [xs(is), xs(is + 1)]
+
+      real, intent(in):: a, b
+      real mean_lin(n2, n3, n4)
+
+      !---------------------------------------------
+
+      if (slope_present) then
+         mean_lin = slope(is, :, :, :) / 2. * (a + b - xs(is) - xs(is + 1)) &
+              + vs(is, :, :, :)
+      else
+         mean_lin = vs(is, :, :, :)
+      end if
+
+    end function mean_lin
+
+  end subroutine regr14_conserv
+
+end module regr1_conserv_m
Index: /LMDZ5/branches/testing/libf/misc/slopes_m.F90
===================================================================
--- /LMDZ5/branches/testing/libf/misc/slopes_m.F90	(revision 2471)
+++ /LMDZ5/branches/testing/libf/misc/slopes_m.F90	(revision 2471)
@@ -0,0 +1,226 @@
+module slopes_m
+
+  ! Author: Lionel GUEZ
+
+  implicit none
+
+  interface slopes
+     ! This generic function computes second order slopes with Van
+     ! Leer slope-limiting, given cell averages. Reference: Dukowicz,
+     ! 1987, SIAM Journal on Scientific and Statistical Computing, 8,
+     ! 305.
+
+     ! The only difference between the specific functions is the rank
+     ! of the first argument and the equal rank of the result.
+
+     ! real, intent(in), rank >= 1:: f ! (n, ...) cell averages, n must be >= 1
+     ! real, intent(in):: x(:) ! (n + 1) cell edges
+     ! real slopes, same shape as f ! (n, ...)
+
+     module procedure slopes1, slopes2, slopes3, slopes4
+  end interface
+
+  private
+  public slopes
+
+contains
+
+  pure function slopes1(f, x)
+
+    real, intent(in):: f(:)
+    real, intent(in):: x(:)
+    real slopes1(size(f))
+
+    ! Local:
+    integer n, i
+    real xc(size(f)) ! (n) cell centers
+    real h
+
+    !------------------------------------------------------
+
+    n = size(f)
+    forall (i = 1:n) xc(i) = (x(i) + x(i + 1)) / 2.
+    slopes1(1) = 0.
+    slopes1(n) = 0.
+
+    do i = 2, n - 1
+       if (f(i) >= max(f(i - 1), f(i + 1)) .or. f(i) &
+            <= min(f(i - 1), f(i + 1))) then
+          ! Local extremum
+          slopes1(i) = 0.
+       else
+          ! (f(i - 1), f(i), f(i + 1)) strictly monotonous
+
+          ! Second order slope:
+          slopes1(i) = (f(i + 1) - f(i - 1)) / (xc(i + 1) - xc(i - 1))
+
+          ! Slope limitation:
+          h = abs(x(i + 1) - xc(i))
+          slopes1(i) = sign(min(abs(slopes1(i)), abs(f(i + 1) - f(i)) / h, &
+               abs(f(i) - f(i - 1)) / h), slopes1(i))
+       end if
+    end do
+
+  end function slopes1
+
+  !*************************************************************
+
+  pure function slopes2(f, x)
+
+    real, intent(in):: f(:, :)
+    real, intent(in):: x(:)
+    real slopes2(size(f, 1), size(f, 2))
+
+    ! Local:
+    integer n, i, j
+    real xc(size(f, 1)) ! (n) cell centers
+    real h(2:size(f, 1) - 1), delta_xc(2:size(f, 1) - 1) ! (2:n - 1)
+
+    !------------------------------------------------------
+
+    n = size(f, 1)
+    forall (i = 1:n) xc(i) = (x(i) + x(i + 1)) / 2.
+
+    forall (i = 2:n - 1) 
+       h(i) = abs(x(i + 1) - xc(i))
+       delta_xc(i) = xc(i + 1) - xc(i - 1)
+    end forall
+
+    do j = 1, size(f, 2)
+       slopes2(1, j) = 0.
+
+       do i = 2, n - 1
+          if (f(i, j) >= max(f(i - 1, j), f(i + 1, j)) .or. &
+               f(i, j) <= min(f(i - 1, j), f(i + 1, j))) then
+             ! Local extremum
+             slopes2(i, j) = 0.
+          else
+             ! (f(i - 1, j), f(i, j), f(i + 1, j))
+             ! strictly monotonous
+
+             ! Second order slope:
+             slopes2(i, j) = (f(i + 1, j) - f(i - 1, j)) / delta_xc(i)
+
+             ! Slope limitation:
+             slopes2(i, j) = sign(min(abs(slopes2(i, j)), &
+                  abs(f(i + 1, j) - f(i, j)) / h(i), &
+                  abs(f(i, j) - f(i - 1, j)) / h(i)), slopes2(i, j))
+          end if
+       end do
+
+       slopes2(n, j) = 0.
+    end do
+
+  end function slopes2
+
+  !*************************************************************
+
+  pure function slopes3(f, x)
+
+    real, intent(in):: f(:, :, :)
+    real, intent(in):: x(:)
+    real slopes3(size(f, 1), size(f, 2), size(f, 3))
+
+    ! Local:
+    integer n, i, j, k
+    real xc(size(f, 1)) ! (n) cell centers
+    real h(2:size(f, 1) - 1), delta_xc(2:size(f, 1) - 1) ! (2:n - 1)
+
+    !------------------------------------------------------
+
+    n = size(f, 1)
+    forall (i = 1:n) xc(i) = (x(i) + x(i + 1)) / 2.
+
+    forall (i = 2:n - 1) 
+       h(i) = abs(x(i + 1) - xc(i))
+       delta_xc(i) = xc(i + 1) - xc(i - 1)
+    end forall
+
+    do k = 1, size(f, 3)
+       do j = 1, size(f, 2)
+          slopes3(1, j, k) = 0.
+
+          do i = 2, n - 1
+             if (f(i, j, k) >= max(f(i - 1, j, k), f(i + 1, j, k)) .or. &
+                  f(i, j, k) <= min(f(i - 1, j, k), f(i + 1, j, k))) then
+                ! Local extremum
+                slopes3(i, j, k) = 0.
+             else
+                ! (f(i - 1, j, k), f(i, j, k), f(i + 1, j, k))
+                ! strictly monotonous
+
+                ! Second order slope:
+                slopes3(i, j, k) = (f(i + 1, j, k) - f(i - 1, j, k)) &
+                     / delta_xc(i)
+
+                ! Slope limitation:
+                slopes3(i, j, k) = sign(min(abs(slopes3(i, j, k)), &
+                     abs(f(i + 1, j, k) - f(i, j, k)) / h(i), &
+                     abs(f(i, j, k) - f(i - 1, j, k)) / h(i)), slopes3(i, j, k))
+             end if
+          end do
+
+          slopes3(n, j, k) = 0.
+       end do
+    end do
+
+  end function slopes3
+
+  !*************************************************************
+
+  pure function slopes4(f, x)
+
+    real, intent(in):: f(:, :, :, :)
+    real, intent(in):: x(:)
+    real slopes4(size(f, 1), size(f, 2), size(f, 3), size(f, 4))
+
+    ! Local:
+    integer n, i, j, k, l
+    real xc(size(f, 1)) ! (n) cell centers
+    real h(2:size(f, 1) - 1), delta_xc(2:size(f, 1) - 1) ! (2:n - 1)
+
+    !------------------------------------------------------
+
+    n = size(f, 1)
+    forall (i = 1:n) xc(i) = (x(i) + x(i + 1)) / 2.
+
+    forall (i = 2:n - 1) 
+       h(i) = abs(x(i + 1) - xc(i))
+       delta_xc(i) = xc(i + 1) - xc(i - 1)
+    end forall
+
+    do l = 1, size(f, 4)
+       do k = 1, size(f, 3)
+          do j = 1, size(f, 2)
+             slopes4(1, j, k, l) = 0.
+
+             do i = 2, n - 1
+                if (f(i, j, k, l) >= max(f(i - 1, j, k, l), f(i + 1, j, k, l)) &
+                     .or. f(i, j, k, l) &
+                     <= min(f(i - 1, j, k, l), f(i + 1, j, k, l))) then
+                   ! Local extremum
+                   slopes4(i, j, k, l) = 0.
+                else
+                   ! (f(i - 1, j, k, l), f(i, j, k, l), f(i + 1, j, k, l))
+                   ! strictly monotonous
+
+                   ! Second order slope:
+                   slopes4(i, j, k, l) = (f(i + 1, j, k, l) &
+                        - f(i - 1, j, k, l)) / delta_xc(i)
+
+                   ! Slope limitation:
+                   slopes4(i, j, k, l) = sign(min(abs(slopes4(i, j, k, l)), &
+                        abs(f(i + 1, j, k, l) - f(i, j, k, l)) / h(i), &
+                        abs(f(i, j, k, l) - f(i - 1, j, k, l)) / h(i)), &
+                        slopes4(i, j, k, l))
+                end if
+             end do
+
+             slopes4(n, j, k, l) = 0.
+          end do
+       end do
+    end do
+
+  end function slopes4
+
+end module slopes_m
